require "isodoc"
require "fileutils"
require_relative "base_convert"

module IsoDoc
  module NIST
    # A {Converter} implementation that generates PDF HTML output, and a
    # document schema encapsulation of the document for validation
    class PdfConvert < IsoDoc::XslfoPdfConvert
      def initialize(options)
        @libdir = File.dirname(__FILE__)
        super
      end

      def pdf_stylesheet(docxml)
        series =  docxml&.at(ns("//bibdata/series/abbreviation"))&.text
        case series
        when "NIST CSWP" then "nist.cswp.xsl" 
        when "NIST CSTS" then "nist.csts.xsl" 
        else "nist.sp.xsl"
        end
      end
    end
  end
end

